<template>
   <div class="reservation">
      <div class="reservation-date">
         <div class="date">{{ name ? name : format(formattedDate, "dd.MM") }}</div>
         <div class="day-of-week">{{ daysOfWeekNames[dayOfWeek] }}</div>
      </div>
      <div class="reservation-block">
         <div
            v-for="reservation in reservations"
            :key="reservation.id"
            class="item"
            :style="{ backgroundColor: reservation.object_id?.color }"
         >
            <div class="hours">
               {{ reservation.hour_start.substring(0, 5) }} - {{ reservation.hour_end.substring(0, 5) }}
            </div>
            <div class="name">{{ reservation.name }}</div>
            <div class="group">Grupa: {{ reservation.group_id?.name }}</div>
            <div class="place">Objekt: {{ reservation.object_id?.name }} {{ reservation.object_id?.place }}</div>
         </div>
      </div>
   </div>
</template>

<script lang="ts" setup>
import { addDays, format, getDay } from "date-fns"
import { useReservation, type IReservation } from "@/views/reservations/store.ts"
import { ref, watch, onMounted } from "vue"
const props = defineProps<{
   date: Date
   days: number
   color: string
}>()
const formattedDate = addDays(props.date, props.days),
   store = useReservation(),
   dayOfWeek = getDay(formattedDate),
   daysOfWeekNames = ["Niedziela", "Poniedziałek", "Wtorek", "Środa", "Czwartek", "Piątek", "Sobota"],
   reservationsData = ref<IReservation[]>(store.data),
   reservations = ref<IReservation[]>([])

let date = addDays(props.date, props.days),
   name: string = ""

date = new Date(date)
onMounted(() => {
   filterReservations()
})

watch(
   () => store.data,
   (newVal) => {
      reservationsData.value = newVal
      filterReservations()
   }
)

function filterReservations() {
   reservations.value = reservationsData.value.filter(
      (reservation) => format(new Date(reservation.date), "yyyy.dd.MM") === format(date, "yyyy.dd.MM")
   )
   sort()
}

function sort() {
   reservations.value.sort((a, b) => {
      const reservationA = a.hour_start
      const reservationB = b.hour_start
      if (reservationA < reservationB) {
         return -1
      }
      if (reservationA > reservationB) {
         return 1
      }
      return 0
   })
}

switch (props.days) {
   case 0: {
      name = "Dzisiaj"
      break
   }
   case 1: {
      name = "Jutro"
      break
   }
   case -1: {
      name = "Wczoraj"
      break
   }
}
</script>

<style>
.reservation {
   font-size: 15px;
   border-radius: 15px;
   .reservation-date {
      display: flex;
      align-items: center;
      flex-direction: column;
      padding: 16px;

      .date {
         font-weight: 600;
      }
   }

   .reservation-block {
      display: flex;
      align-items: center;
      scroll-snap-align: start;
      border-radius: 5%;
      flex-direction: column;

      .item {
         background-color: var(--yellow-2);
         margin-bottom: 16px;
         padding: 12px;
         border-radius: 4px;
         width: 100%;

         .hours {
            font-size: 110%;
            border-radius: 2px;
            font-weight: 600;
         }
      }
   }
}
</style>
